#include "AFMotor.h"
#include "DFRobotDFPlayerMini.h"
#include "SoftwareSerial.h"

#define LED1 A5
#define LED2 A3
#define BUZZER A0
#define MUSIC 2

AF_DCMotor motor1(1, MOTOR12_1KHZ);
AF_DCMotor motor2(2, MOTOR12_1KHZ);
AF_DCMotor motor3(3);
AF_DCMotor motor4(4);

SoftwareSerial mySoftwareSerial(13, 2);
DFRobotDFPlayerMini myDFPlayer;

int current_music = 0;
int buzz = 0;
int change = 0;

void setup() 
{
  Serial.begin(9600);
  mySoftwareSerial.begin(9600);
 
  pinMode(LED1, OUTPUT);
  pinMode(LED2, OUTPUT);
  pinMode(BUZZER, OUTPUT);

  myDFPlayer.begin(mySoftwareSerial, true);
  delay(1000);
  myDFPlayer.volume(30);
}

void loop() 
{
  
  int i;
  char command;
  if(Serial.available() > 0){ 
    command = Serial.read();
    switch(command){
    case 'X':
      for (i = 0; i < 100; ++i) {
        digitalWrite(BUZZER, HIGH);
        delay(1);
        digitalWrite(BUZZER, LOW);
        delay(1);
      }
    case 'x':
        for (i = 0; i < 100; ++i) {
          
          digitalWrite(BUZZER, HIGH);
          delay(1);
          digitalWrite(BUZZER, LOW);
          delay(1);
        }
    case 'S':
      Stop();
      break;
    case 'V':
      current_music++;
      if (current_music > MUSIC) {
        current_music = 1;
      }
      myDFPlayer.playMp3Folder(current_music);
      break;
    case 'v':
      myDFPlayer.stop();
      break;
    case 'W':
      digitalWrite(LED1, HIGH);
      digitalWrite(LED2, HIGH);
      break;
    case 'w':
      digitalWrite(LED1, LOW);
      digitalWrite(LED2, LOW);
      break;
    case 'F':
      forward();
      break;
    case 'B':
      back();
      break;
    case 'L':
      left();
      break;
    case 'R':
      right();
      break;
    default:
      Serial.println(command);
      break;
    }
  }
}

void forward()
{
  motor1.run(FORWARD);
  motor1.setSpeed(255);
  motor2.run(FORWARD);
  motor2.setSpeed(255);
  motor3.run(FORWARD);
  motor3.setSpeed(255);
  motor4.run(FORWARD);
  motor4.setSpeed(255);
}

void back()
{
  motor1.setSpeed(255);
  motor1.run(BACKWARD);
  motor2.setSpeed(255);
  motor2.run(BACKWARD);
  motor3.setSpeed(255);
  motor3.run(BACKWARD);
  motor4.setSpeed(255);
  motor4.run(BACKWARD);
}

void left()
{
  motor1.setSpeed(255);
  motor1.run(FORWARD);
  motor2.setSpeed(255);
  motor2.run(BACKWARD);
  motor3.setSpeed(255);
  motor3.run(BACKWARD);
  motor4.setSpeed(255);
  motor4.run(FORWARD);
}

void right()
{
  motor1.setSpeed(255);
  motor1.run(BACKWARD);
  motor2.setSpeed(255);
  motor2.run(FORWARD);
  motor3.setSpeed(255);
  motor3.run(FORWARD);
  motor4.setSpeed(255);
  motor4.run(BACKWARD);
} 

void Stop()
{
  motor1.setSpeed(0);
  motor1.run(RELEASE);
  motor2.setSpeed(0);
  motor2.run(RELEASE);
  motor3.setSpeed(0);
  motor3.run(RELEASE);
  motor4.setSpeed(0);
  motor4.run(RELEASE);
}
